-- Test add_campsite_type_option
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to camper, public;

select has_function('camper', 'add_campsite_type_option', array['uuid', 'text', 'integer', 'integer', 'boolean']);
select function_lang_is('camper', 'add_campsite_type_option', array['uuid', 'text', 'integer', 'integer', 'boolean'], 'sql');
select function_returns('camper', 'add_campsite_type_option', array['uuid', 'text', 'integer', 'integer', 'boolean'], 'integer');
select isnt_definer('camper', 'add_campsite_type_option', array['uuid', 'text', 'integer', 'integer', 'boolean']);
select volatility_is('camper', 'add_campsite_type_option', array['uuid', 'text', 'integer', 'integer', 'boolean'], 'volatile');
select function_privs_are('camper', 'add_campsite_type_option', array ['uuid', 'text', 'integer', 'integer', 'boolean'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_campsite_type_option', array ['uuid', 'text', 'integer', 'integer', 'boolean'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_campsite_type_option', array ['uuid', 'text', 'integer', 'integer', 'boolean'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_campsite_type_option', array ['uuid', 'text', 'integer', 'integer', 'boolean'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type_option_i18n cascade;
truncate campsite_type_option cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, slug, media_id, name, description, active, max_campers, bookable_nights)
values (3, 1, '87452b88-b48f-48d3-bb6c-0296de64164e', 2, 'Type A', '<p>A</p>', true, 4, '[1, 7]')
     , (4, 1, '9ae5cf87-cd69-4541-b5a5-75f937cc9e58', 2, 'Type B', '<p>B</p>', true, 5, '[1, 6]')
;

select lives_ok(
	$$ select add_campsite_type_option('87452b88-b48f-48d3-bb6c-0296de64164e', 'Option 1', 0, 10, true) $$,
	'Should be able to add an option to the first campsite type'
);

select lives_ok(
	$$ select add_campsite_type_option('9ae5cf87-cd69-4541-b5a5-75f937cc9e58', 'Option 2', 5, 15, false) $$,
	'Should be able to add an option to the second campsite type'
);

select bag_eq(
	$$ select campsite_type_id, name, range, per_night from campsite_type_option $$,
	$$ values (3, 'Option 1', '[0, 10]'::int4range, true)
	        , (4, 'Option 2', '[5, 15]'::int4range, false)
	$$,
	'Should have added all two campsite type options'
);

select is_empty(
	$$ select * from campsite_type_option_i18n $$,
	'Should not have added any translation for campsite type options.'
);

select *
from finish();

rollback;
